//+------------------------------------------------------------------+
//|                                #AAD (Daily Range Calculator).mq4 |
//|                      Copyright  2006, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Ogeima - Some Mods by AAD..."
#property link      "ph_bresson@yahoo.com"

#property indicator_separate_window
//---- input parameters
extern double  Risk_to_Reward_ratio =  3.0;
extern int First_av = 5;
extern int Second_av = 10;
extern int Third_av = 20;
int nDigits;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
IndicatorShortName("AAD's TSR");
   if(Symbol()=="GBPJPY" || Symbol()=="EURJPY" || Symbol()=="USDJPY" || Symbol()=="GOLD" || Symbol()=="USDMXN") nDigits = 2;
   if(Symbol()=="GBPUSD" || Symbol()=="EURUSD" || Symbol()=="NZDUSD" || Symbol()=="USDCHF"  ||
   Symbol()=="USDCAD" || Symbol()=="AUDUSD" || Symbol()=="EURUSD" || Symbol()=="EURCHF"  || Symbol()=="EURGBP"
   || Symbol()=="EURCAD" || Symbol()=="EURAUD" )nDigits = 4;

   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
  // Comment(""); 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   //----
   int R1=0,R5=0,R10=0,R20=0,RAvg=0;
   int RoomUp=0,RoomDown=0,StopLoss_Long=0,StopLoss_Short=0;
   double   SL_Long=0,SL_Short=0;
   double   low0=0,high0=0;
   string   Text="";
   int i=0;

   R1 =  (iHigh(NULL,PERIOD_D1,1)-iLow(NULL,PERIOD_D1,1))/Point;
   for(i=1;i<=First_av;i++)
      R5    =    R5  +  (iHigh(NULL,PERIOD_D1,i)-iLow(NULL,PERIOD_D1,i))/Point;
   for(i=1;i<=Second_av;i++)
      R10   =    R10 +  (iHigh(NULL,PERIOD_D1,i)-iLow(NULL,PERIOD_D1,i))/Point;
   for(i=1;i<=Third_av;i++)
      R20   =    R20 +  (iHigh(NULL,PERIOD_D1,i)-iLow(NULL,PERIOD_D1,i))/Point;

   R5 = R5/First_av;
   R10 = R10/Second_av;
   R20 = R20/Third_av;
   RAvg  =  (R1+R5+R10+R20)/4; //RAvg  =  (R5+R10+R20)/3;new setting    

   low0  =  iLow(NULL,PERIOD_D1,0);
   high0 =  iHigh(NULL,PERIOD_D1,0);
   RoomUp   =  RAvg - (Bid - low0)/Point;
   RoomDown =  RAvg - (high0 - Bid)/Point;
   StopLoss_Long  =  RoomUp/Risk_to_Reward_ratio;
   SL_Long        =  Bid - StopLoss_Long*Point;
   StopLoss_Short =  RoomDown/Risk_to_Reward_ratio;
   SL_Short       =  Bid + StopLoss_Short*Point;


   Text =   "Average Day  Range: " +  RAvg + "\n"  + 
            "Prev 01  Day  Range: " +  R1   + "\n" + 
            "Prev 05  Days Range: " +  R5   + "\n" + 
            "Prev 10  Days Range: " +  R10  + "\n" +
            "Prev 20  Days Range: " +  R20  + "\n";
   Text =   Text +
            "Room Up: " + RoomUp + "\n" +
            "Room Down: " + RoomDown + "\n" +
            "Maximum StopLosses" + "\n" +
            "Long: " + StopLoss_Long + "Pips at" + DoubleToStr(SL_Long,nDigits) + "\n" +
            "Short: " + StopLoss_Short + "Pips at" + DoubleToStr(SL_Short,nDigits) + "\n";

   //Comment(Text);
  
   string P=Period();
  
   
        ObjectCreate("AAD's TSR", OBJ_LABEL, WindowFind("AAD's TSR"), 0, 0);
        ObjectSetText("AAD's TSR",StringSubstr(Symbol(),0),10, "Arial Bold", SkyBlue);
        ObjectSet("AAD's TSR", OBJPROP_CORNER, 0);
        ObjectSet("AAD's TSR", OBJPROP_XDISTANCE, 55);
        ObjectSet("AAD's TSR", OBJPROP_YDISTANCE, 2);
        ObjectCreate("AAD's TSR1", OBJ_LABEL, WindowFind("AAD's TSR"), 0, 0);
        ObjectSetText("AAD's TSR1",StringSubstr(P,0),11, "Arial Bold", Gold);
        ObjectSet("AAD's TSR1", OBJPROP_CORNER, 0);
        ObjectSet("AAD's TSR1", OBJPROP_XDISTANCE, 115);
        ObjectSet("AAD's TSR1", OBJPROP_YDISTANCE, 2);
        
        ObjectCreate("AAD's TSR2", OBJ_LABEL, WindowFind("AAD's TSR"), 0, 0);
        ObjectSetText("AAD's TSR2","Average Daily Range:", 10, "Arial Bold", SkyBlue);
        ObjectSet("AAD's TSR2", OBJPROP_CORNER, 0);
        ObjectSet("AAD's TSR2", OBJPROP_XDISTANCE, 160);
        ObjectSet("AAD's TSR2", OBJPROP_YDISTANCE, 2);
        ObjectCreate("AAD's TSR3", OBJ_LABEL, WindowFind("AAD's TSR"), 0, 0);
        ObjectSetText("AAD's TSR3",DoubleToStr(RAvg ,0),11, "Arial Bold", Gold);
        ObjectSet("AAD's TSR3", OBJPROP_CORNER, 0);
        ObjectSet("AAD's TSR3", OBJPROP_XDISTANCE, 301);
        ObjectSet("AAD's TSR3", OBJPROP_YDISTANCE, 2);
        
        ObjectCreate("AAD's TSR4", OBJ_LABEL, WindowFind("AAD's TSR"), 0, 0);
        ObjectSetText("AAD's TSR4","Prev 1 Day Range:", 10, "Arial ", SkyBlue);
        ObjectSet("AAD's TSR4", OBJPROP_CORNER, 0);
        ObjectSet("AAD's TSR4", OBJPROP_XDISTANCE, 5);
        ObjectSet("AAD's TSR4", OBJPROP_YDISTANCE, 20);
        ObjectCreate("AAD's TSR5", OBJ_LABEL, WindowFind("AAD's TSR"), 0, 0);
        ObjectSetText("AAD's TSR5",DoubleToStr(R1,0),11, "Arial Bold", Gold);
        ObjectSet("AAD's TSR5", OBJPROP_CORNER, 0);
        ObjectSet("AAD's TSR5", OBJPROP_XDISTANCE, 123);
        ObjectSet("AAD's TSR5", OBJPROP_YDISTANCE, 22);
        
        ObjectCreate("AAD's TSR6", OBJ_LABEL, WindowFind("AAD's TSR"), 0, 0);
        ObjectSetText("AAD's TSR6","Prev "+First_av+" Days Range:", 10, "Arial ", SkyBlue);
        ObjectSet("AAD's TSR6", OBJPROP_CORNER, 0);
        ObjectSet("AAD's TSR6", OBJPROP_XDISTANCE, 5);
        ObjectSet("AAD's TSR6", OBJPROP_YDISTANCE, 35);
        ObjectCreate("AAD's TSR7", OBJ_LABEL, WindowFind("AAD's TSR"), 0, 0);
        ObjectSetText("AAD's TSR7",DoubleToStr(R5,0),11, "Arial Bold", Gold);
        ObjectSet("AAD's TSR7", OBJPROP_CORNER, 0);
        ObjectSet("AAD's TSR7", OBJPROP_XDISTANCE, 130);
        ObjectSet("AAD's TSR7", OBJPROP_YDISTANCE, 37);
        
        ObjectCreate("AAD's TSR8", OBJ_LABEL, WindowFind("AAD's TSR"), 0, 0);
        ObjectSetText("AAD's TSR8","Prev "+Second_av+" Days Range:", 10, "Arial ", SkyBlue);
        ObjectSet("AAD's TSR8", OBJPROP_CORNER, 0);
        ObjectSet("AAD's TSR8", OBJPROP_XDISTANCE, 180);
        ObjectSet("AAD's TSR8", OBJPROP_YDISTANCE, 22);
        ObjectCreate("AAD's TSR9", OBJ_LABEL, WindowFind("AAD's TSR"), 0, 0);
        ObjectSetText("AAD's TSR9",DoubleToStr(R10,0),11, "Arial Bold", Gold);
        ObjectSet("AAD's TSR9", OBJPROP_CORNER, 0);
        ObjectSet("AAD's TSR9", OBJPROP_XDISTANCE, 312);
        ObjectSet("AAD's TSR9", OBJPROP_YDISTANCE, 22);
        
        ObjectCreate("AAD's TSR10", OBJ_LABEL, WindowFind("AAD's TSR"), 0, 0);
        ObjectSetText("AAD's TSR10","Prev "+Third_av+" Days Range:", 10, "Arial ", SkyBlue);
        ObjectSet("AAD's TSR10", OBJPROP_CORNER, 0);
        ObjectSet("AAD's TSR10", OBJPROP_XDISTANCE, 185);
        ObjectSet("AAD's TSR10", OBJPROP_YDISTANCE, 35);
        ObjectCreate("AAD's TSR11", OBJ_LABEL, WindowFind("AAD's TSR"), 0, 0);
        ObjectSetText("AAD's TSR11",DoubleToStr(R20,0),11, "Arial Bold", Gold);
        ObjectSet("AAD's TSR11", OBJPROP_CORNER, 0);
        ObjectSet("AAD's TSR11", OBJPROP_XDISTANCE, 316);
        ObjectSet("AAD's TSR11", OBJPROP_YDISTANCE, 37);
        
        ObjectCreate("AAD's TSR12", OBJ_LABEL, WindowFind("AAD's TSR"), 0, 0);
        ObjectSetText("AAD's TSR12","Room UP:", 10, "Arial ", SkyBlue);
        ObjectSet("AAD's TSR12", OBJPROP_CORNER, 0);
        ObjectSet("AAD's TSR12", OBJPROP_XDISTANCE, 365);
        ObjectSet("AAD's TSR12", OBJPROP_YDISTANCE, 22);
        ObjectCreate("AAD's TSR13", OBJ_LABEL, WindowFind("AAD's TSR"), 0, 0);
        ObjectSetText("AAD's TSR13",DoubleToStr(RoomUp,0),11, "Arial Bold", Gold);
        ObjectSet("AAD's TSR13", OBJPROP_CORNER, 0);
        ObjectSet("AAD's TSR13", OBJPROP_XDISTANCE, 432);
        ObjectSet("AAD's TSR13", OBJPROP_YDISTANCE, 22);
        
        ObjectCreate("AAD's TSR14", OBJ_LABEL, WindowFind("AAD's TSR"), 0, 0);
        ObjectSetText("AAD's TSR14","Room DN:", 10, "Arial ", SkyBlue);
        ObjectSet("AAD's TSR14", OBJPROP_CORNER, 0);
        ObjectSet("AAD's TSR14", OBJPROP_XDISTANCE, 370);
        ObjectSet("AAD's TSR14", OBJPROP_YDISTANCE, 37);
        ObjectCreate("AAD's TSR15", OBJ_LABEL, WindowFind("AAD's TSR"), 0, 0);
        ObjectSetText("AAD's TSR15",DoubleToStr(RoomDown,0),11, "Arial Bold", Gold);
        ObjectSet("AAD's TSR15", OBJPROP_CORNER, 0);
        ObjectSet("AAD's TSR15", OBJPROP_XDISTANCE, 436);
        ObjectSet("AAD's TSR15", OBJPROP_YDISTANCE, 37);
        
        ObjectCreate("AAD's TSR16", OBJ_LABEL, WindowFind("AAD's TSR"), 0, 0);
        ObjectSetText("AAD's TSR16","Maximum StopLosses;",10, "Arial Bold", SkyBlue);
        ObjectSet("AAD's TSR16", OBJPROP_CORNER, 0);
        ObjectSet("AAD's TSR16", OBJPROP_XDISTANCE, 529);
        ObjectSet("AAD's TSR16", OBJPROP_YDISTANCE, 2);
        
        ObjectCreate("AAD's TSR17", OBJ_LABEL, WindowFind("AAD's TSR"), 0, 0);
        ObjectSetText("AAD's TSR17","Long:             Pips at:", 10, "Arial ", SkyBlue);
        ObjectSet("AAD's TSR17", OBJPROP_CORNER, 0);
        ObjectSet("AAD's TSR17", OBJPROP_XDISTANCE, 515);
        ObjectSet("AAD's TSR17", OBJPROP_YDISTANCE, 22);
        ObjectCreate("AAD's TSR18", OBJ_LABEL, WindowFind("AAD's TSR"), 0, 0);
        ObjectSetText("AAD's TSR18",DoubleToStr(StopLoss_Long,0),11, "Arial Bold", Blue);
        ObjectSet("AAD's TSR18", OBJPROP_CORNER, 0);
        ObjectSet("AAD's TSR18", OBJPROP_XDISTANCE, 549);
        ObjectSet("AAD's TSR18", OBJPROP_YDISTANCE, 23);
        
        ObjectCreate("AAD's TSR19", OBJ_LABEL, WindowFind("AAD's TSR"), 0, 0);
        ObjectSetText("AAD's TSR19","Short:             Pips at:", 10, "Arial ", SkyBlue);
        ObjectSet("AAD's TSR19", OBJPROP_CORNER, 0);
        ObjectSet("AAD's TSR19", OBJPROP_XDISTANCE, 515);
        ObjectSet("AAD's TSR19", OBJPROP_YDISTANCE, 37);
        ObjectCreate("AAD's TSR20", OBJ_LABEL, WindowFind("AAD's TSR"), 0, 0);
        ObjectSetText("AAD's TSR20",DoubleToStr(StopLoss_Short,0),11, "Arial Bold", Red);
        ObjectSet("AAD's TSR20", OBJPROP_CORNER, 0);
        ObjectSet("AAD's TSR20", OBJPROP_XDISTANCE, 551);
        ObjectSet("AAD's TSR20", OBJPROP_YDISTANCE, 38);
        
        ObjectCreate("AAD's TSR21", OBJ_LABEL, WindowFind("AAD's TSR"), 0, 0);
        ObjectSetText("AAD's TSR21",DoubleToStr(SL_Long,nDigits),11, "Arial Bold", Blue);
        ObjectSet("AAD's TSR21", OBJPROP_CORNER, 0);
        ObjectSet("AAD's TSR21", OBJPROP_XDISTANCE, 635);
        ObjectSet("AAD's TSR21", OBJPROP_YDISTANCE, 23);
        ObjectCreate("AAD's TSR22", OBJ_LABEL, WindowFind("AAD's TSR"), 0, 0);
        ObjectSetText("AAD's TSR22",DoubleToStr(SL_Short,nDigits),11, "Arial Bold",Red);
        ObjectSet("AAD's TSR22", OBJPROP_CORNER, 0);
        ObjectSet("AAD's TSR22", OBJPROP_XDISTANCE, 635);
        ObjectSet("AAD's TSR22", OBJPROP_YDISTANCE, 38);
        
        ObjectCreate("AAD's TSR23", OBJ_LABEL, WindowFind("AAD's TSR"), 0, 0);
        ObjectSetText("AAD's TSR23","Risk to Reward Ratio:", 10, "Arial Bold", SkyBlue);
        ObjectSet("AAD's TSR23", OBJPROP_CORNER, 0);
        ObjectSet("AAD's TSR23", OBJPROP_XDISTANCE, 350);
        ObjectSet("AAD's TSR23", OBJPROP_YDISTANCE, 2);
        ObjectCreate("AAD's TSR24", OBJ_LABEL, WindowFind("AAD's TSR"), 0, 0);
        ObjectSetText("AAD's TSR24",DoubleToStr( Risk_to_Reward_ratio ,0),11, "Arial Bold", Gold);
        ObjectSet("AAD's TSR24", OBJPROP_CORNER, 0);
        ObjectSet("AAD's TSR24", OBJPROP_XDISTANCE, 490);
        ObjectSet("AAD's TSR24", OBJPROP_YDISTANCE, 3);
        
     
        double HIDaily = iMA(Symbol(),PERIOD_D1,1,0,MODE_HIGH,PRICE_HIGH,0);
        double LOWDaily = iMA(Symbol(),PERIOD_D1,1,0,MODE_LOW,PRICE_LOW,0); 
        //double YEST_HIDaily = iMA(Symbol(),PERIOD_D1,1,0,MODE_HIGH,PRICE_HIGH,1);
        //double YEST_LOWDaily = iMA(Symbol(),PERIOD_D1,1,0,MODE_LOW,PRICE_LOW,1); 
   
        ObjectCreate("high", OBJ_LABEL, WindowFind("AAD's TSR"), 0, 0);
        ObjectSetText("high",DoubleToStr(HIDaily,Digits), 11, "Arial Bold", Blue);
        ObjectSet("high", OBJPROP_CORNER, 0);
        ObjectSet("high", OBJPROP_XDISTANCE, 805);
        ObjectSet("high", OBJPROP_YDISTANCE, 22);
        
        ObjectCreate("high2", OBJ_LABEL, WindowFind("AAD's TSR"), 0, 0);
        ObjectSetText("high2","DailyHigh", 10, "Arial Bold", SkyBlue);
        ObjectSet("high2", OBJPROP_CORNER, 0);
        ObjectSet("high2", OBJPROP_XDISTANCE, 798);
        ObjectSet("high2", OBJPROP_YDISTANCE, 2);
        
        ObjectCreate("low", OBJ_LABEL, WindowFind("AAD's TSR"), 0, 0);
        ObjectSetText("low",DoubleToStr(LOWDaily,Digits), 11, "Arial Bold", Red);
        ObjectSet("low", OBJPROP_CORNER, 0);
        ObjectSet("low", OBJPROP_XDISTANCE, 736);
        ObjectSet("low", OBJPROP_YDISTANCE, 22);
        
        ObjectCreate("low2", OBJ_LABEL, WindowFind("AAD's TSR"), 0, 0);
        ObjectSetText("low2","DailyLow", 10, "Arial Bold", SkyBlue);
        ObjectSet("low2", OBJPROP_CORNER, 0);
        ObjectSet("low2", OBJPROP_XDISTANCE, 728);
        ObjectSet("low2", OBJPROP_YDISTANCE, 2);
        
         double CURR = iMA(Symbol(),0,1,0,MODE_EMA,PRICE_CLOSE,0);
   
           
        ObjectCreate("high3", OBJ_LABEL, WindowFind("AAD's TSR"), 0, 0);
        ObjectSetText("high3",DoubleToStr(CURR,Digits), 11, "Arial Bold", Blue);
        ObjectSet("high3", OBJPROP_CORNER, 0);
        ObjectSet("high3", OBJPROP_XDISTANCE, 805);
        ObjectSet("high3", OBJPROP_YDISTANCE, 37);
            
        ObjectCreate("high4", OBJ_LABEL, WindowFind("AAD's TSR"), 0, 0);
        ObjectSetText("high4",DoubleToStr(CURR,Digits), 11, "Arial Bold", Red);
        ObjectSet("high4", OBJPROP_CORNER, 0);
        ObjectSet("high4", OBJPROP_XDISTANCE, 737);
        ObjectSet("high4", OBJPROP_YDISTANCE, 37);
        
        ObjectCreate("low4", OBJ_LABEL, WindowFind("AAD's TSR"), 0, 0);
        ObjectSetText("low4","Today:", 10, "Arial ", SkyBlue);
        ObjectSet("low4", OBJPROP_CORNER, 0);
        ObjectSet("low4", OBJPROP_XDISTANCE, 689);
        ObjectSet("low4", OBJPROP_YDISTANCE, 22);
        ObjectCreate("low5", OBJ_LABEL, WindowFind("AAD's TSR"), 0, 0);
        ObjectSetText("low5","Now:", 10, "Arial ", SkyBlue);
        ObjectSet("low5", OBJPROP_CORNER, 0);
        ObjectSet("low5", OBJPROP_XDISTANCE, 702);
        ObjectSet("low5", OBJPROP_YDISTANCE, 37);
   
   


   return(0);
  }
//+------------------------------------------------------------------+